<script lang="ts">
type SwitchPortRowData = {
  createdTime: string;
  diagInfo: NdmSwitchDiagInfo;
};
</script>

<script setup lang="ts">
import { pageSnmpLogApi, type NdmSwitchDiagInfo, type NdmSwitchPortInfo, type NdmSwitchResultVO, type PageParams, type Station } from '@/apis';
import { getPortStatusValue, transformPortSpeed } from '@/helpers';
import { parseErrorFeedback } from '@/utils';
import { useMutation } from '@tanstack/vue-query';
import { isCancel } from 'axios';
import dayjs from 'dayjs';
import destr from 'destr';
import { NButton, NCard, NDataTable, NModal, type DataTableColumns, type DataTableRowData, type PaginationProps } from 'naive-ui';
import { h, onBeforeUnmount, reactive, ref, toRefs, watch } from 'vue';

const props = defineProps<{
  ndmDevice: NdmSwitchResultVO;
  station: Station;
}>();

const range = defineModel<[number, number]>('range');
const loading = defineModel<boolean>('loading', { default: false });

const emit = defineEmits<{
  exposeQueryFn: [queryFn: () => void];
}>();

const { ndmDevice, station } = toRefs(props);

const showDetailModal = ref(false);

const detailTableColumns: DataTableColumns<NdmSwitchPortInfo> = [
  { title: '端口名称', key: 'portName' },
  {
    title: '状态',
    key: 'upDown',
    render(rowData) {
      return getPortStatusValue(rowData);
    },
  },
  {
    title: '上行速率',
    key: 'inFlow',
    render(rowData) {
      return transformPortSpeed(rowData, 'in');
    },
  },
  {
    title: '下行速率',
    key: 'outFlow',
    render(rowData) {
      return transformPortSpeed(rowData, 'out');
    },
  },
  {
    title: '总速率',
    key: 'totalFlow',
    render(rowData) {
      return transformPortSpeed(rowData, 'total');
    },
  },
];

const detailTableData = ref<DataTableRowData[]>([]);

const tableColumns: DataTableColumns<SwitchPortRowData> = [
  { title: '诊断时间', key: 'createdTime' },
  {
    title: '超载端口',
    key: 'overFlowPorts',
    render(rowData) {
      const { diagInfo } = rowData;
      const { info } = diagInfo;
      const { overFlowPorts } = info ?? {};
      return h('pre', {}, { default: () => overFlowPorts?.join('\n') ?? '' });
    },
  },
  {
    title: '操作',
    key: 'action',
    render(rowData) {
      return h(
        NButton,
        {
          text: true,
          type: 'info',
          onClick: () => {
            const { diagInfo } = rowData;
            if (!diagInfo) return;
            showDetailModal.value = true;
            detailTableData.value = diagInfo.info?.portInfoList ?? [];
          },
        },
        { default: () => '查看' },
      );
    },
  },
];

const tableData = ref<DataTableRowData[]>([]);
const DEFAULT_PAGE_SIZE = 10;
const pagination = reactive<PaginationProps>({
  size: 'small',
  showSizePicker: true,
  page: 1,
  pageSize: DEFAULT_PAGE_SIZE,
  pageSizes: [5, 10, 20, 50, 80, 100],
  itemCount: 0,
  prefix: ({ itemCount }) => {
    return h('div', {}, { default: () => `共${itemCount}条` });
  },
  onUpdatePage: (page) => {
    pagination.page = page;
    getTableData();
  },
  onUpdatePageSize: (pageSize) => {
    pagination.pageSize = pageSize;
    pagination.page = 1;
    getTableData();
  },
});

const abortController = ref<AbortController>(new AbortController());

const { mutate: getTableData, isPending } = useMutation({
  mutationFn: async () => {
    if (!range.value) throw new Error('请选择时间范围');
    abortController.value?.abort();
    abortController.value = new AbortController();
    const deviceId = ndmDevice.value.id;
    if (!deviceId) throw new Error('该设备没有ID');
    const createdTime_precisest = dayjs(range.value[0]).format('YYYY-MM-DD HH:mm:ss');
    const createdTime_preciseed = dayjs(range.value[1]).format('YYYY-MM-DD HH:mm:ss');
    const restParams: Omit<PageParams<{ id: string }>, 'model' | 'extra'> = {
      current: pagination.page ?? 1,
      size: pagination.pageSize ?? DEFAULT_PAGE_SIZE,
      sort: 'id',
      order: 'descending',
    };
    const pageResult = await pageSnmpLogApi(
      {
        model: { deviceId },
        extra: { createdTime_precisest, createdTime_preciseed },
        ...restParams,
      },
      {
        stationCode: station.value.code,
      },
    );
    return pageResult;
  },
  onSuccess: ({ records, size, total }) => {
    pagination.pageSize = parseInt(size);
    pagination.itemCount = parseInt(total);
    tableData.value = records.map((record) => {
      const diagInfoJsonString = record.diagInfo;
      const diagInfo = destr<NdmSwitchDiagInfo>(diagInfoJsonString);
      if (!diagInfo) return {};
      if (typeof diagInfo !== 'object') return {};
      return {
        createdTime: record.createdTime,
        diagInfo,
      };
    });
  },
  onError: (error) => {
    if (isCancel(error)) return;
    console.error(error);
    const errorFeedback = parseErrorFeedback(error);
    window.$message.error(errorFeedback);
  },
});

emit('exposeQueryFn', () => {
  pagination.page = 1;
  pagination.pageSize = DEFAULT_PAGE_SIZE;
  getTableData();
});

watch(isPending, (pending) => {
  loading.value = pending;
});

onBeforeUnmount(() => {
  abortController.value.abort();
});
</script>

<template>
  <NCard hoverable size="small">
    <template #header>
      <span>端口速率记录</span>
    </template>
    <template #default>
      <NDataTable size="small" :loading="isPending" :columns="tableColumns" :data="tableData" :pagination="pagination" :single-line="false" remote flex-height style="height: 500px" />
    </template>
  </NCard>
  <NModal v-model:show="showDetailModal" :preset="'card'" :auto-focus="false" :transform-origin="'center'" :content-style="{ height: '100%' }" style="min-width: 1440px; height: 100vh">
    <NDataTable size="small" :columns="detailTableColumns" :data="detailTableData" :single-line="false" :remote="false" flex-height style="height: 100%" />
  </NModal>
</template>

<style scoped lang="scss"></style>
